/*******************************************************************************
Vendor: Xilinx 
Associated Filename: window_fn_top.h
Purpose:Vivado HLSwindow_fn_fxpt example project
Revision History: March 13, 2012 - initial release
                                                
*******************************************************************************
Copyright (C) 2013 XILINX, Inc. 

This file contains confidential and proprietary information of Xilinx, Inc. and 
is protected under U.S. and international copyright and other intellectual 
property laws.

DISCLAIMER
This disclaimer is not a license and does not grant any rights to the materials 
distributed herewith. Except as otherwise provided in a valid license issued to 
you by Xilinx, and to the maximum extent permitted by applicable law: 
(1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND XILINX 
HEREBY DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, 
INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT, OR 
FITNESS FOR ANY PARTICULAR PURPOSE; and (2) Xilinx shall not be liable (whether 
in contract or tort, including negligence, or under any other theory of 
liability) for any loss or damage of any kind or nature related to, arising under 
or in connection with these materials, including for any direct, or any indirect, 
special, incidental, or consequential loss or damage (including loss of data, 
profits, goodwill, or any type of loss or damage suffered as a result of any 
action brought by a third party) even if such damage or loss was reasonably 
foreseeable or Xilinx had been advised of the possibility of the same.

CRITICAL APPLICATIONS
Xilinx products are not designed or intended to be fail-safe, or for use in any 
application requiring fail-safe performance, such as life-support or safety 
devices or systems, Class III medical devices, nuclear facilities, applications 
related to the deployment of airbags, or any other applications that could lead 
to death, personal injury, or severe property or environmental damage 
(individually and collectively, "Critical Applications"). Customer assumes the 
sole risk and liability of any use of Xilinx products in Critical Applications, 
subject only to applicable laws and regulations governing limitations on product 
liability. 

THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT 
ALL TIMES.

*******************************************************************************/
#ifndef WINDOW_FN_TOP_H_
#define WINDOW_FN_TOP_H_

#include "window_fn_class.h"

// Test parameters
#define WIN_TYPE xhls_window_fn::HANN
#define WIN_LEN 32

// Types and top-level function prototype
#include <ap_int.h>
// Define widths of fixed point fields
#define W_IN    8
#define IW_IN   8
#define W_OUT   24
#define IW_OUT  8
#define W_COEF  18
#define IW_COEF 2

// Define fixed  point types for input, output and coefficients
typedef ap_fixed<W_IN,IW_IN> win_fn_in_t;
typedef ap_fixed<W_OUT,IW_OUT> win_fn_out_t;
typedef ap_fixed<W_COEF,IW_COEF> win_fn_coef_t;

// Top level function prototype - wraps all object, method and functions for HLS
void window_fn_top(win_fn_out_t outdata[WIN_LEN], win_fn_in_t indata[WIN_LEN]);

#endif // WINDOW_FN_TOP_H_
